/********************************** (C) COPYRIGHT *******************************
 * File Name          : Main.c
 * Author             : WCH
 * Version            : V1.0
 * Date               : 2024/07/09
 * Description        : WS2812 16*16SPI+DMA
 *******************************************************************************/

#include "CH58x_common.h"
#include "../src/WS281X_SPI/WS281X.H"
#include "../SRC/usart/usart.h"
#include "../SRC/urtc/urtc.h"
#include "../SRC/Keyscan/keyscan.h"

#define SYSTICK_INTERVAL    (10)             //  λΪ

uint8_t StrBuff[100]="Have a good day!";

uint8_t testd[30]={0x00,0xFC,0x90,0x90,0x60,0x00,0x00,0x7C,0x90,0x90,0x7C,0x00,0x00,0xFC,0xA4,0xA4,0x58,0x00,0x00,0x78,0x84,0x84,0x48,0x00,0x00,0xFC,0x84,0x84,0x78,0x00,};
/*********************************************************************
 * @fn      DebugInit
 *
 * @brief   Գʼ
 *
 * @return  none
 */
volatile uint8_t PlayMode = 1 ;
volatile uint8_t Half_Second_Flag ;
uint8_t KeyValue ;
int main()
{
    PWR_DCDCCfg(ENABLE);

    uint8_t i;
    SetSysClock(CLK_SOURCE_PLL_60MHz);

    GPIOA_ModeCfg( GPIO_Pin_All, GPIO_ModeIN_PU );
    GPIOB_ModeCfg( GPIO_Pin_All, GPIO_ModeIN_PD );

    WS2812x_Power_Set(ENABLE);

    Key_init();

    /* ôڵ */
    DebugInit();
    PRINT("Start @ChipID=%02X\n", R8_CHIP_ID);
    PRINT( "Time=%s-%s\n",__TIME__,__DATE__ );

    SysTick_Config(GetSysClock() / 1000 * SYSTICK_INTERVAL);
    SysTick->SR = 0;                    //жϱ־
    PFIC_DisableIRQ(SysTick_IRQn);

    RTC_Init();
    WX281X_Init();

    while(1)
    {
        if(SysTick->SR)
        {
            SysTick->SR = 0;

            KeyValue = key_read();
            if(KEY_Event_Click == KeyValue)
            {
                PlayMode++;
                if(PlayMode == 5)PlayMode = 1 ;
                switch(PlayMode)
                {
                    case 2 :Function_state_1 = 0 ;PlayFunction_1();break ;
                    case 1 :Function_state_4 = 0 ;PlayFunction_4(0,64,8);break ;
                    case 3 :Function_state_3 = 0 ;PlayFunction_3(&StrBuff[0],0,0,80);break ;
                    case 4 :Function_state_4 = 0 ;PlayFunction_4(0,64,8);break ;
                }
            }
            else if(KEY_Event_Press == KeyValue)
            {
                ARGB_FillRGB(0, 0, 0);

                PRINT( "sleep mode sleep \n" );
                DelayMs( 10 );
                WS2812x_Power_Set(DISABLE);

                while(!GPIOB_ReadPortPin(GPIO_Pin_0));

                LowPower_Sleep(RB_PWR_RAM30K | RB_PWR_RAM2K); //ֻ30+2K SRAM 
                //LowPower_Halt();

                HSECFG_Current( HSE_RCur_100 );     // Ϊ(͹ĺHSEƫõ)
                DelayMs( 5 );

                WS2812x_Power_Set(ENABLE);
                PRINT( "wake.. \n" );

                DelayMs( 500 );
             }


            Usart_scan();

            switch(PlayMode)
            {
                case 2 :PlayFunction_1();break ;
                case 1 :PlayFunction_4(0,64,8);break ;
                case 3 :PlayFunction_3(&StrBuff[0],0,0,80);break ;
                case 4 :PlayFunction_4(0,64,8);break ;
            }

        }
    }
}
